# -*- coding: utf-8 -*-

# python 2.7
# (C) Fabrice Sincère

# nécessite les droits superutilisateurs avec Raspian Wheezy

# Bibliographie :
# https://sourceforge.net/p/raspberry-gpio-python/wiki/BasicUsage
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Outputs/
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Inputs/

version = "1.0.3"

import sys

print """
+-----------------------------------------------------+
| Commande d'une LED sur le port GPIO du Raspberry Pi |
+-----------------------------------------------------+

Version {}
""".format(version)

try:
    import RPi.GPIO as GPIO
except:
    print sys.exc_info()[1]
    sys.exit(1)


# choix de la broche de sortie

GPIO.setmode(GPIO.BOARD) # board numbering system

print """
Connecteur GPIO 40 broches

+--+--+--+-----+--+
| 2| 4| 6|.....|40|
+--+--+--+-----+--+
| 1| 3| 5|.....|39|
+--+--+--+-----+--+
"""

defaultchannel = 16 # position sur le connecteur 40 broches

try:
    channel = int(raw_input("N° de broche du GPIO ? "))
except:
    channel = defaultchannel

# shows the function of a GPIO channel
try:
    func = GPIO.gpio_function(channel)
    # nécessite les droits superutilisateurs avec Raspian Wheezy
except:
    print sys.exc_info()[1]
    sys.exit(2)

if func not in [GPIO.IN, GPIO.OUT]:
    # GPIO.SPI, GPIO.I2C, GPIO.HARD_PWM, GPIO.SERIAL, GPIO.UNKNOWN
    funcs = {0:"OUT", 1:"IN", 42:"I2C", 41:"SPI", 40:"SERIAL", -1:"UNKNOWN", 43:"HARD_PWM"}
    print "Broche non utilisable ({})".format(funcs[func])
    sys.exit(3)

GPIO.setup(channel, GPIO.OUT) # set up a channel as an output

print "\nConfiguration de la broche n°{} en sortie [OK]\n".format(channel)


# lecture niveau initial
if GPIO.input(channel) == False:    # read the value of a GPIO pin
    print "La LED est actuellement éteinte (niveau 0)"
else:
    print "La LED est actuellement allumée (niveau 1)"


while True:

    choix = raw_input("\nChanger l'état de la LED (c) ou quitter (q) ? ")

    if choix == "c":
        # toggle
        # GPIO.output(channel, not GPIO.input(channel)) # autre technique

        if GPIO.input(channel) == False:
            # sortie mis à 1
            GPIO.output(channel, GPIO.HIGH)
            # relecture pour vérification
            if GPIO.input(channel) == True:
                print "La LED est maintenant allumée"
            else:
                print "Erreur inattendue"

        else:
            # sortie mis à 0
            GPIO.output(channel, GPIO.LOW)
            # relecture pour vérification
            if GPIO.input(channel) == False:
                print "La LED est maintenant éteinte"
            else:
                print "Erreur inattendue"

    if choix == "q":
        # quitter
        GPIO.cleanup(channel)
        break

print "Bye !"


