# -*- coding: utf-8 -*-

# python 2.7
# (C) Fabrice Sincère

# nécessite les droits superutilisateurs avec Raspbian Wheezy

# Bibliographie :
# https://sourceforge.net/p/raspberry-gpio-python/wiki/BasicUsage
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Outputs/
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Inputs/

print """
+-----------------------------------------------------+
| Commande d'une LED sur le port GPIO du Raspberry Pi |
+-----------------------------------------------------+
"""

import RPi.GPIO as GPIO

# choix de la broche de sortie

GPIO.setmode(GPIO.BOARD) # board numbering system

channel = 16 # position sur le connecteur 40 broches

GPIO.setup(channel, GPIO.OUT) # set up a channel as an output

# lecture niveau initial
if GPIO.input(channel) == False:    # read the value of a GPIO pin
    print "La LED est actuellement éteinte (niveau 0)"
else:
    print "La LED est actuellement allumée (niveau 1)"


while True:

    choix = raw_input("\nChanger l'état de la LED (c) ou quitter (q) ? ")

    if choix == "c":
        # toggle
        # GPIO.output(channel, not GPIO.input(channel)) # autre technique

        if GPIO.input(channel) == False:
            # sortie mis à 1
            GPIO.output(channel, GPIO.HIGH)
            print "La LED est maintenant allumée"
            
        else:
            # sortie mis à 0
            GPIO.output(channel, GPIO.LOW)
            print "La LED est maintenant éteinte"
            
    if choix == "q":
        # quitter
        GPIO.cleanup(channel)
        break

print "Bye !"


