# -*- coding: utf-8 -*-

# python 2.7
# (C) Fabrice Sincère

# nécessite les droits superutilisateurs avec Raspian Wheezy
# attention : ne fonctionne pas depuis IDLE

# Bibliographie :
# https://sourceforge.net/p/raspberry-gpio-python/wiki/BasicUsage
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Outputs/
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Inputs/

version = "1.0.0"

import sys
import time

print """
+----------------------------------------------------------------------+
| Configuration en entrée et lecture sur le port GPIO du Raspberry Pi  |
+----------------------------------------------------------------------+

Version {}
""".format(version)

try:
    import RPi.GPIO as GPIO
except:
    print sys.exc_info()[1]
    sys.exit(1)


# choix de la broche

GPIO.setmode(GPIO.BOARD) # board numbering system

print """
Connecteur GPIO 40 broches

+--+--+--+-----+--+
| 2| 4| 6|.....|40|
+--+--+--+-----+--+
| 1| 3| 5|.....|39|
+--+--+--+-----+--+
"""

defaultchannel = 22 # position sur le connecteur 40 broches

try:
    channel = int(raw_input("N° de broche du GPIO ? "))
except:
    channel = defaultchannel

# shows the function of a GPIO channel
try:
    func = GPIO.gpio_function(channel)
    # nécessite les droits superutilisateurs avec Raspian Wheezy
except:
    print sys.exc_info()[1]
    sys.exit(2)

funcs = {0:"OUT", 1:"IN", 42:"I2C", 41:"SPI", 40:"SERIAL", -1:"UNKNOWN", 43:"HARD_PWM"}

if func not in [GPIO.IN, GPIO.OUT]:
    # GPIO.SPI, GPIO.I2C, GPIO.HARD_PWM, GPIO.SERIAL, GPIO.UNKNOWN    
    print "Broche non disponible ({})".format(funcs[func])
    sys.exit(3)

# setup 

GPIO.setwarnings(False) # disable warnings
# "this channel is already in use, continuing anyway"

GPIO.setup(channel, GPIO.IN, pull_up_down=GPIO.PUD_UP) # configuration en entrée

print """Configuration de la broche n°{} en entrée
avec résistance de pull-up activée [OK]

Veuillez brancher un interrupteur ou un bouton poussoir entre la broche n°{} et GND
""".format(channel, channel)

def affichageniveau(channel):
    if GPIO.input(channel) == True:
        # niveau 1
        # interrupteur ouvert
        print "OFF",
    else:
        # niveau 0
        # interrupteur fermé
        print "ON ",
    # timestamp
    print "[{}]".format(time.time())

# lecture niveau
if GPIO.input(channel) == False:    # read the value of a GPIO pin
    print "ON"
else:
    print "OFF"

# threaded callback (mécanisme disponible uniquement sur des entrées)
# attention : ne fonctionne pas depuis IDLE

# edge detection & antirebonds
GPIO.add_event_detect(channel, GPIO.BOTH, callback=affichageniveau, bouncetime=10)

raw_input("""En attente d'évenements...
Touche Enter pour quitter.
""")

GPIO.cleanup(channel)
print "Bye !"
