# -*- coding: utf-8 -*-

# python 2.7
# (C) Fabrice Sincère

# nécessite les droits superutilisateurs avec Raspbian Wheezy
# attention : ne fonctionne pas depuis IDLE

# Bibliographie :
# https://sourceforge.net/p/raspberry-gpio-python/wiki/BasicUsage
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Outputs/
# https://sourceforge.net/p/raspberry-gpio-python/wiki/Inputs/


print """
+----------------------------------------------+
| Configuration en entrée de la broche 22      |
| et lecture sur le port GPIO du Raspberry Pi  |
+----------------------------------------------+
"""

import RPi.GPIO as GPIO

# choix de la broche
GPIO.setmode(GPIO.BOARD) # board numbering system

channel = 22 # position sur le connecteur 40 broches

# setup 

GPIO.setwarnings(False) # disable warnings
# "this channel is already in use, continuing anyway"

GPIO.setup(channel, GPIO.IN, pull_up_down=GPIO.PUD_UP) # configuration en entrée

def affichageniveau(channel):
    if GPIO.input(channel) == True:  # read the value of a GPIO pin
        # niveau 1
        # interrupteur ouvert
        print "OFF"
    else:
        # niveau 0
        # interrupteur fermé
        print "ON "


# lecture niveau initial
affichageniveau(channel)

# threaded callback (mécanisme disponible uniquement sur des entrées)
# attention : ne fonctionne pas depuis IDLE

# edge detection & antirebonds
GPIO.add_event_detect(channel, GPIO.BOTH, callback=affichageniveau, bouncetime=10)

raw_input("""En attente d'évenements...
Touche Enter pour quitter.
""")

GPIO.cleanup(channel)
print "Bye !"
